
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include <netdb.h>
#include <stdarg.h>     /* we need va_list */


#include <termios.h>
#include <fcntl.h>
#include <getopt.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "post.h"

int init_post(char* host, int port) 
{
    int s;
    struct sockaddr_in sin;
    struct hostent *he;
    struct in_addr *host_addr;

    he = gethostbyname(host);

    if ((s=socket(PF_INET, SOCK_STREAM, 0))<0) {
	perror("socket()");
	return -1;
    }

    memset(&sin, 0, sizeof(struct sockaddr_in));
    sin.sin_family=AF_INET;
    sin.sin_port=htons(port);

    host_addr = (struct in_addr *)he->h_addr;
    sin.sin_addr.s_addr = host_addr->s_addr;

    if (connect(s, (struct sockaddr *)&sin, sizeof(struct sockaddr_in))==-1) {
	perror("connect()");
	return -1;
    }
    return s;
}

static void prt(int s, const char *fmt, ...)
{
    char buf[800];
    va_list va;

    va_start(va, fmt);
    vsnprintf(buf,800,fmt,va);
    write(s,buf,strlen(buf));
}

int post_xml(int s, char*url, char*headers, char*content )
{
    int l;

    l = strlen(content);
    prt(s,"POST %s HTTP/1.1\r\n",url);
    prt(s,"Content-Length: %d\r\n",l);
    if (headers) {
	prt(s,"%s", headers);
    }
    prt(s,"\r\n");
    l=write(s,content,l);
    prt(s,"\r\n");
    return l;
}

int read_answer(int s )
{
    char buf[800];
    int ret=0;

    while ((ret = read(s,buf,800))>0) {
	write(1,buf,ret); // to stdout
    }
    return ret; // last command.
}
